"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    compileDisjointReasonsMessage: ()=>compileDisjointReasonsMessage,
    writeImplicitNeverMessage: ()=>writeImplicitNeverMessage,
    writeUndiscriminatableMorphUnionMessage: ()=>writeUndiscriminatableMorphUnionMessage,
    writeIndivisibleMessage: ()=>writeIndivisibleMessage,
    writeUnboundableMessage: ()=>writeUnboundableMessage
});
const _composeTs = require("../../nodes/compose.js");
const _genericsTs = require("../../utils/generics.js");
const compileDisjointReasonsMessage = (disjoints)=>{
    const paths = (0, _genericsTs.keysOf)(disjoints);
    if (paths.length === 1) {
        const path = paths[0];
        return `${path === "/" ? "" : `At ${path}: `}Intersection of ${_composeTs.disjointDescriptionWriters[disjoints[path].kind](disjoints[path])} results in an unsatisfiable type`;
    }
    let message = `
        "Intersection results in unsatisfiable types at the following paths:\n`;
    for(const path1 in disjoints){
        message += `  ${path1}: ${_composeTs.disjointDescriptionWriters[disjoints[path1].kind](disjoints[path1])}\n`;
    }
    return message;
};
const writeImplicitNeverMessage = (path, operator, description)=>`${path.length ? `At ${path}: ` : ""}${operator} ${description ? `${description} ` : ""}results in an unsatisfiable type`;
const writeUndiscriminatableMorphUnionMessage = (path)=>`${path === "/" ? "A" : `At ${path}, a`} union including one or more morphs must be discriminatable`;
const writeIndivisibleMessage = (root)=>`Divisibility operand ${root} must be a number`;
const writeUnboundableMessage = (root)=>`Bounded expression ${root} must be a number, string or array`;
