import { disjointDescriptionWriters } from "../../nodes/compose.js";
import { keysOf } from "../../utils/generics.js";
export const compileDisjointReasonsMessage = (disjoints)=>{
    const paths = keysOf(disjoints);
    if (paths.length === 1) {
        const path = paths[0];
        return `${path === "/" ? "" : `At ${path}: `}Intersection of ${disjointDescriptionWriters[disjoints[path].kind](disjoints[path])} results in an unsatisfiable type`;
    }
    let message = `
        "Intersection results in unsatisfiable types at the following paths:\n`;
    for(const path1 in disjoints){
        message += `  ${path1}: ${disjointDescriptionWriters[disjoints[path1].kind](disjoints[path1])}\n`;
    }
    return message;
};
export const writeImplicitNeverMessage = (path, operator, description)=>`${path.length ? `At ${path}: ` : ""}${operator} ${description ? `${description} ` : ""}results in an unsatisfiable type`;
export const writeUndiscriminatableMorphUnionMessage = (path)=>`${path === "/" ? "A" : `At ${path}, a`} union including one or more morphs must be discriminatable`;
export const writeIndivisibleMessage = (root)=>`Divisibility operand ${root} must be a number`;
export const writeUnboundableMessage = (root)=>`Bounded expression ${root} must be a number, string or array`;
