import { jsObjects, jsObjectsScope } from "./jsObjects.js";
import { scope } from "./scope.js";
import { tsKeywords, tsKeywordsScope } from "./tsKeywords.js";
import { validation, validationScope } from "./validation.js";
export const standardScope = scope({}, {
    name: "standard",
    includes: [
        tsKeywords,
        jsObjects,
        validation
    ],
    standard: false
});
export const standard = standardScope.compile();
export const scopes = {
    tsKeywords: tsKeywordsScope,
    jsObjects: jsObjectsScope,
    validation: validationScope,
    standard: standardScope
};
export const spaces = {
    tsKeywords,
    jsObjects,
    validation,
    standard
};
export const type = scopes.standard.type;
