import type { Morph } from "../parse/tuple/morph.js";
import type { Domain } from "../utils/domains.js";
import type { CollapsibleList, Dict, List } from "../utils/generics.js";
import type { IntersectionState, Intersector } from "./compose.js";
import type { FlattenContext } from "./node.js";
import type { PredicateComparison } from "./predicate.js";
import type { Rules } from "./rules/rules.js";
export type Branch<domain extends Domain = Domain, $ = Dict> = Rules<domain, $> | MorphBranch<domain, $>;
export type MorphBranch<domain extends Domain = Domain, $ = Dict> = {
    rules: Rules<domain, $>;
    morph: CollapsibleList<Morph>;
};
export type Branches = List<Branch>;
export type MorphEntry = ["morph", CollapsibleList<Morph>];
export declare const isBranchComparison: (comparison: PredicateComparison) => comparison is BranchesComparison;
export type BranchesComparison = {
    lBranches: Branches;
    rBranches: Branches;
    lExtendsR: number[];
    rExtendsL: number[];
    equalities: [lIndex: number, rIndex: number][];
    distinctIntersections: Branches;
};
export declare const compareBranches: (lConditions: Branches, rConditions: Branches, state: IntersectionState) => BranchesComparison;
export declare const isMorphBranch: (branch: Branch) => branch is MorphBranch<keyof {
    bigint: bigint;
    boolean: boolean;
    number: number;
    object: object;
    string: string;
    symbol: symbol;
    undefined: undefined;
    null: null;
}, Dict>;
export declare const flattenBranch: (branch: Branch, ctx: FlattenContext) => import("./node.js").TraversalEntry[];
export declare const branchIntersection: Intersector<Branch>;
