import type { InferredObjectKinds } from "../utils/objectKinds.js";
import type { Space } from "./scope.js";
import type { TypeParser } from "./type.js";
export declare const standardScope: import("./scope.js").Scope<[{
    any: any;
    bigint: bigint;
    boolean: boolean;
    false: false;
    never: never;
    null: null;
    number: number;
    object: object;
    string: string;
    symbol: symbol;
    true: true;
    unknown: unknown;
    void: void;
    undefined: undefined;
    Function: (...args: any[]) => unknown;
    Array: unknown[];
    Date: Date;
    Error: Error;
    Map: Map<unknown, unknown>;
    RegExp: RegExp;
    Set: Set<unknown>;
    Object: {
        [x: string]: unknown;
    };
    String: String;
    Number: Number;
    Boolean: Boolean;
    WeakMap: WeakMap<object, unknown>;
    WeakSet: WeakSet<object>;
    Promise: Promise<unknown>;
    alpha: string;
    alphanumeric: string;
    lowercase: string;
    uppercase: string;
    creditCard: string;
    email: string;
    uuid: string;
    integer: number;
}, {}, false]>;
export declare const standard: Space<{
    any: any;
    bigint: bigint;
    boolean: boolean;
    false: false;
    never: never;
    null: null;
    number: number;
    object: object;
    string: string;
    symbol: symbol;
    true: true;
    unknown: unknown;
    void: void;
    undefined: undefined;
    Function: (...args: any[]) => unknown;
    Array: unknown[];
    Date: Date;
    Error: Error;
    Map: Map<unknown, unknown>;
    RegExp: RegExp;
    Set: Set<unknown>;
    Object: {
        [x: string]: unknown;
    };
    String: String;
    Number: Number;
    Boolean: Boolean;
    WeakMap: WeakMap<object, unknown>;
    WeakSet: WeakSet<object>;
    Promise: Promise<unknown>;
    alpha: string;
    alphanumeric: string;
    lowercase: string;
    uppercase: string;
    creditCard: string;
    email: string;
    uuid: string;
    integer: number;
}>;
export declare const scopes: {
    tsKeywords: import("./scope.js").Scope<[{
        any: any;
        bigint: bigint;
        boolean: boolean;
        false: false;
        never: never;
        null: null;
        number: number;
        object: object;
        string: string;
        symbol: symbol;
        true: true;
        unknown: unknown;
        void: void;
        undefined: undefined;
    }, {}, false]>;
    jsObjects: import("./scope.js").Scope<[{
        Function: (...args: any[]) => unknown;
        Array: unknown[];
        Date: Date;
        Error: Error;
        Map: Map<unknown, unknown>;
        RegExp: RegExp;
        Set: Set<unknown>;
        Object: {
            [x: string]: unknown;
        };
        String: String;
        Number: Number;
        Boolean: Boolean;
        WeakMap: WeakMap<object, unknown>;
        WeakSet: WeakSet<object>;
        Promise: Promise<unknown>;
    }, {}, false]>;
    validation: import("./scope.js").Scope<[{
        alpha: string;
        alphanumeric: string;
        lowercase: string;
        uppercase: string;
        creditCard: string;
        email: string;
        uuid: string;
        integer: number;
    }, {}, false]>;
    standard: import("./scope.js").Scope<[{
        any: any;
        bigint: bigint;
        boolean: boolean;
        false: false;
        never: never;
        null: null;
        number: number;
        object: object;
        string: string;
        symbol: symbol;
        true: true;
        unknown: unknown;
        void: void;
        undefined: undefined;
        Function: (...args: any[]) => unknown;
        Array: unknown[];
        Date: Date;
        Error: Error;
        Map: Map<unknown, unknown>;
        RegExp: RegExp;
        Set: Set<unknown>;
        Object: {
            [x: string]: unknown;
        };
        String: String;
        Number: Number;
        Boolean: Boolean;
        WeakMap: WeakMap<object, unknown>;
        WeakSet: WeakSet<object>;
        Promise: Promise<unknown>;
        alpha: string;
        alphanumeric: string;
        lowercase: string;
        uppercase: string;
        creditCard: string;
        email: string;
        uuid: string;
        integer: number;
    }, {}, false]>;
};
export declare const spaces: {
    tsKeywords: Space<{
        any: any;
        bigint: bigint;
        boolean: boolean;
        false: false;
        never: never;
        null: null;
        number: number;
        object: object;
        string: string;
        symbol: symbol;
        true: true;
        unknown: unknown;
        void: void;
        undefined: undefined;
    }>;
    jsObjects: Space<{
        Function: (...args: any[]) => unknown;
        Array: unknown[];
        Date: Date;
        Error: Error;
        Map: Map<unknown, unknown>;
        RegExp: RegExp;
        Set: Set<unknown>;
        Object: {
            [x: string]: unknown;
        };
        String: String;
        Number: Number;
        Boolean: Boolean;
        WeakMap: WeakMap<object, unknown>;
        WeakSet: WeakSet<object>;
        Promise: Promise<unknown>;
    }>;
    validation: Space<{
        alpha: string;
        alphanumeric: string;
        lowercase: string;
        uppercase: string;
        creditCard: string;
        email: string;
        uuid: string;
        integer: number;
    }>;
    standard: Space<{
        any: any;
        bigint: bigint;
        boolean: boolean;
        false: false;
        never: never;
        null: null;
        number: number;
        object: object;
        string: string;
        symbol: symbol;
        true: true;
        unknown: unknown;
        void: void;
        undefined: undefined;
        Function: (...args: any[]) => unknown;
        Array: unknown[];
        Date: Date;
        Error: Error;
        Map: Map<unknown, unknown>;
        RegExp: RegExp;
        Set: Set<unknown>;
        Object: {
            [x: string]: unknown;
        };
        String: String;
        Number: Number;
        Boolean: Boolean;
        WeakMap: WeakMap<object, unknown>;
        WeakSet: WeakSet<object>;
        Promise: Promise<unknown>;
        alpha: string;
        alphanumeric: string;
        lowercase: string;
        uppercase: string;
        creditCard: string;
        email: string;
        uuid: string;
        integer: number;
    }>;
};
export type PrecompiledDefaults = {
    any: any;
    bigint: bigint;
    boolean: boolean;
    false: false;
    never: never;
    null: null;
    number: number;
    object: object;
    string: string;
    symbol: symbol;
    true: true;
    unknown: unknown;
    void: void;
    undefined: undefined;
    integer: number;
    alpha: string;
    alphanumeric: string;
    lowercase: string;
    uppercase: string;
    creditCard: string;
    email: string;
    uuid: string;
} & InferredObjectKinds;
export declare const type: TypeParser<PrecompiledDefaults>;
